/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is QrAuth.
 *
 * The Initial Developer of the Original Code is
 * Maximilien Cuony.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// QrAuth - Génération de l'image - (C) Maximilien Cuony [The_glu] http://theglu.org

import javax.microedition.lcdui.*;
/**
 *
 * @author maximilien
 */
public class QrCanevas extends javax.microedition.lcdui.Canvas {
    
    int data[][];
    
    public void paint(Graphics g) 
    {
        //Effacage

        //On met du blanc
        g.setColor(255, 255, 255);
        g.fillRect(0, 0,getWidth(), getHeight());

        g.setColor(255, 255, 0);

        g.fillRect((int)(getWidth() - 200) / 2, (int)(getHeight() - 200) / 2, 200, 200);


        int numOfC = this.data.length;
        
        int taileOfC = 200/(numOfC);

         for (int i=0; i < numOfC; i++) {

             for (int j=0; j < numOfC; j++) {

                 if (this.data[i][j] == 0)
                    g.setColor(255, 255, 255);
                 else
                    g.setColor(0, 0, 0);
                 
                 int x = (int)((getWidth() - 200) / 2 + 200 * j /numOfC);
                 int y = (int)((getHeight() - 200) / 2 + 200 * i /numOfC);

                 g.fillRect(x, y, taileOfC +1 , taileOfC +1);
            }
         }
        
       g.setColor(0, 0, 0);
       
       
       

       
      /* try {
            g.drawString(AeSimpleMD5.MD5(this.generateTheUniqueCode()), 0, 0, 0);
           g.drawString(this.generateTheUniqueCode(), 0, 10, 0);
       } catch (Exception e) {
           g.drawString(e.toString(), 0, 0, 0);
       }*/
        
       
       



    }
    
    public void setData(int[][] data) {
        
        this.data = data;
        
    }
    
    public String generateTheUniqueCode() {
        
        return this.getCurrentDateHeure().concat("mysupersecrectstring");
        
        
  
    }
    
    private String getCurrentDateHeure() {
        
        java.util.Calendar date = java.util.Calendar.getInstance(java.util.TimeZone.getTimeZone("GMT"));
       
        String retour = "";
       
       retour = retour.concat(String.valueOf(date.get(date.YEAR)));
       String month = String.valueOf(date.get(date.MONTH) + 1);
       if (month.length() == 1)
            month = "0".concat(month);
       retour = retour.concat(month);
       
       String day = String.valueOf(date.get(date.DAY_OF_MONTH));
       if (day.length() == 1)
            day = "0".concat(day);
       retour = retour.concat(String.valueOf(day));
       
       
       String hour = String.valueOf(date.get(date.HOUR_OF_DAY));
       if (hour.length() == 1)
            hour = "0".concat(hour);
       retour = retour.concat(String.valueOf(hour));

       
       String minute = String.valueOf(date.get(date.MINUTE));
       if (minute.length() == 1)
            minute = "0".concat(minute);
       retour = retour.concat(String.valueOf(minute));

       return retour;
    }


}
