/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is QrAuth.
 *
 * The Initial Developer of the Original Code is
 * Maximilien Cuony.
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): La logique du code proviens d'une source en PHP de Y.Swetake, http://www.swetake.com/qr
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// QrAuth - Génération de l'image - (C) Maximilien Cuony [The_glu] http://theglu.org

import java.io.*;

/**
 *
 * @author maximilien
 */
public class QrGenerator {
    
    public int[][] generate(String qrcode_data_string) {
        
        
        int data_length = qrcode_data_string.length();
  
        int data_counter=0;
        
        int[] data_bits = new int[36];
        int[] data_value = new int[36];
        

        data_bits[data_counter]=4;

    
        /*  --- 8bit byte mode */

        int[] codeword_num_plus={0,0,0,0,0,0,0,0,0,0,
                                 8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,
                                 8,8,8,8,8,8,8,8,8,8,8,8,8,8};

        data_value[data_counter]=4;
        data_counter++;
        data_value[data_counter]=data_length;
        data_bits[data_counter]=8;   /* #version 1-9 */
        int codeword_num_counter_value= data_counter;

        data_counter++;
        int i=0;
        while (i<data_length){
            data_value[data_counter] = new Character(qrcode_data_string.charAt(i)).hashCode();
            data_bits[data_counter] = 8;
            data_counter++;
            i++;
        }
       

        if (data_bits[data_counter] > 0) {
            data_counter++;
        }
        i=0;
        int total_data_bits=0;
        while(i<data_counter){
            total_data_bits+=data_bits[i];
            i++;
        }
       
        
        /*System.out.println(total_data_bits);
        
        
        for(int ctr=0; ctr<data_bits.length; ctr++){
            System.out.println(data_bits[ctr]);
        }
        
        for(int ctr=0; ctr<data_value.length; ctr++){
            System.out.println(data_value[ctr]);
        }*/
        
        int ec = 1;
        
        int[] max_data_bits_array= {
            0,128,224,352,512,688,864,992,1232,1456,1728,
            2032,2320,2672,2920,3320,3624,4056,4504,5016,5352,
            5712,6256,6880,7312,8000,8496,9024,9544,10136,10984,
            11640,12328,13048,13800,14496,15312,15936,16816,17728,18672,

            152,272,440,640,864,1088,1248,1552,1856,2192,
            2592,2960,3424,3688,4184,4712,5176,5768,6360,6888,
            7456,8048,8752,9392,10208,10960,11744,12248,13048,13880,
            14744,15640,16568,17528,18448,19472,20528,21616,22496,23648,

            72,128,208,288,368,480,528,688,800,976,
            1120,1264,1440,1576,1784,2024,2264,2504,2728,3080,
            3248,3536,3712,4112,4304,4768,5024,5288,5608,5960,
            6344,6760,7208,7688,7888,8432,8768,9136,9776,10208,

            104,176,272,384,496,608,704,880,1056,1232,
            1440,1648,1952,2088,2360,2600,2936,3176,3560,3880,
            4096,4544,4912,5312,5744,6032,6464,6968,7288,7880,
            8264,8920,9368,9848,10288,10832,11408,12016,12656,13328
        };

    
        /* #--- auto version select */
        i=1+40*ec;
        int j=i+39;
        int qrcode_version=1;
        int max_data_bits = 0;
        
        while (i<=j){
            if ((max_data_bits_array[i])>=total_data_bits+codeword_num_plus[qrcode_version]     ){
                max_data_bits = max_data_bits_array[i];
                break;
            }
            i++;
            qrcode_version++;
        }
        

        total_data_bits+=codeword_num_plus[qrcode_version];
    
           
        data_bits[codeword_num_counter_value]+=codeword_num_plus[qrcode_version];

        int [] max_codewords_array = {0,26,44,70,100,134,172,196,242,
            292,346,404,466,532,581,655,733,815,901,991,1085,1156,
            1258,1364,1474,1588,1706,1828,1921,2051,2185,2323,2465,
            2611,2761,2876,3034,3196,3362,3532,3706};

        int max_codewords = max_codewords_array[qrcode_version];
        
        int max_modules_1side=17+(qrcode_version <<2);

        int[] matrix_remain_bit= {0,0,7,7,7,7,7,0,0,0,0,0,0,0,3,3,3,3,3,3,3,
            4,4,4,4,4,4,4,3,3,3,3,3,3,3,0,0,0,0,0,0};
        
        InputStream is = null;
        InputStreamReader is2 = null;
        int readed;
        
        /* ---- read version ECC data file */

        int byte_num= matrix_remain_bit[qrcode_version]+(max_codewords << 3);
        int[] matrix_x_array = new int[byte_num];
        int[] matrix_y_array = new int[byte_num];
        int[] mask_array = new int[byte_num];
        int[] format_information_x2 = new int[15];
        int[] format_information_y2 = new int[15];
        int rs_ecc_codewords = 0;
        int[] rs_block_order = new int[128];
        int rs_block_order_num = 0;

        
        try { 
          is = getClass().getResourceAsStream("qrcode_data/".concat("qrv").concat(String.valueOf(qrcode_version)).concat("_").concat(String.valueOf(ec)).concat(".dat"));
          
          
          i = 0;
          while(i < byte_num) {
              matrix_x_array[i] = is.read();
              i++;
          }
          i = 0;
          while(i < byte_num) {
              matrix_y_array[i] = is.read();
              i++;
          }
          
          i = 0;
          while(i < byte_num) {
              mask_array[i] = is.read();
              i++;
          }
          
          i = 0;
          while(i < 15) {
              format_information_x2[i] = is.read();
              i++;
          }
          i = 0;
          while(i < 15) {
              format_information_y2[i] = is.read();
              i++;
          }
          
          i = 0;
          while(i < 1) {
              i++; readed = is.read();
              rs_ecc_codewords = readed;
          }
          
          i = 0;
          while(i < 128) {
              rs_block_order[i] = is.read();
              if (rs_block_order[i] != -1)
                    rs_block_order_num = i;
              i++;
          }
        } catch (Exception e) {
          e.printStackTrace();
        }

        
        int[] format_information_x1 ={0,1,2,3,4,5,7,8,8,8,8,8,8,8,8};
        int[] format_information_y1 = {8,8,8,8,8,8,8,8,7,5,4,3,2,1,0};

        int max_data_codewords = (max_data_bits >>3);
        
        int[][] rs_cal_table_array = new int[256][rs_ecc_codewords];
        
        
        try { 
          is = getClass().getResourceAsStream("qrcode_data/".concat("rsc").concat(String.valueOf(rs_ecc_codewords)).concat(".dat"));
          
          j = 0;
          while (j<256) {
              
              i = 0;
              while(i < rs_ecc_codewords) {
                  rs_cal_table_array[j][i] = is.read();
                  i++;
              }

              j++;
          }
          
            
         } catch (Exception e) {
          e.printStackTrace();
        }
        
       
        /* -- read frame data  -- */
        int[][] frame_data_splited = new int[64][64];
        int xp = 0;
        int yp = 0;

        try { 
          is = getClass().getResourceAsStream("qrcode_data/".concat("qrvfr").concat(String.valueOf(qrcode_version)).concat(".dat"));
          is2 = new InputStreamReader(is);

          while(-1 != (readed = is2.read())) {
              if (readed == 48) {
                  
                  frame_data_splited[xp][yp] = 0;
                  xp++;
                  
                  
              } else if (readed == 49) {
                  
                  frame_data_splited[xp][yp] = 1;
                  xp++;
                  
              } else {
                  
                  xp = 0;
                  yp++;
                  
                  
              }
          }
        } catch (Exception e) {
          e.printStackTrace();
        }
        
        /*  --- set terminator */

        if (total_data_bits<=max_data_bits-4){
            data_value[data_counter]=0;
            data_bits[data_counter]=4;
        } else {
            if (total_data_bits<max_data_bits){
                data_value[data_counter]=0;
                data_bits[data_counter]=max_data_bits-total_data_bits;
            } else {
                if (total_data_bits>max_data_bits){
                    System.exit(1);
                }
            }
        }

        /* ----divide data by 8bit */

        i=0;
        int codewords_counter=0;
        int[] codewords = new int[999];
        codewords[0] = 0;
        int remaining_bits = 8;

        while (i<=data_counter) {
            int buffer = data_value[i];
            int buffer_bits = data_bits[i];

            int flag=1;
            while (flag == 1) {
                if (remaining_bits>buffer_bits){  
                    codewords[codewords_counter]=((codewords[codewords_counter]<<buffer_bits) | buffer);
                    remaining_bits-=buffer_bits;
                    flag=0;
                } else {
                    buffer_bits-=remaining_bits;
                    codewords[codewords_counter]=((codewords[codewords_counter] << remaining_bits) | (buffer >> buffer_bits));

                    if (buffer_bits==0) {
                        flag=0;
                    } else {
                        buffer= (buffer & ((1 << buffer_bits)-1) );
                        flag=1;   
                    }

                    codewords_counter++;
                    if (codewords_counter<max_data_codewords-1){
                        codewords[codewords_counter]=0;
                    }
                    remaining_bits=8;
                }
            }
            i++;
        }
        if (remaining_bits!=8) {
            codewords[codewords_counter]=codewords[codewords_counter] << remaining_bits;
        } else {
            codewords_counter--;
        }

        /* ----  set padding character */

        if (codewords_counter<max_data_codewords-1){
            int flag=1;
            while (codewords_counter<max_data_codewords-1){
                codewords_counter++;
                if (flag==1) {
                    codewords[codewords_counter]=236;
                } else {
                    codewords[codewords_counter]=17;
                }
                flag=flag*(-1);
            }
        }
        
       
        /* ---- RS-ECC prepare */

        i=0;
        j=0;
        int rs_block_number=0;
        String[] rs_temp = new String[max_data_codewords+1];
        rs_temp[0] = "";

        while(i<max_data_codewords){
            

            rs_temp[rs_block_number] = rs_temp[rs_block_number].concat(new Character((char)codewords[i]).toString());
            j++;

            //System.out.println(rs_block_order[rs_block_number+1]);
            
            if (j>=rs_block_order[rs_block_number]-rs_ecc_codewords){
                j=0;
                rs_block_number++;
                rs_temp[rs_block_number]="";
            }
            i++;
        }
                
        /*
        #
        # RS-ECC main
        #
        */

        rs_block_number=0;
        String rstemp;
        String padding_data = "";
        int codewords_counter_cloned = codewords_counter + 1;
        int[] rstemp2 = new int[999];


        while (rs_block_number<rs_block_order_num+1){

            int rs_codewords=rs_block_order[rs_block_number];
            int rs_data_codewords=rs_codewords-rs_ecc_codewords;

            i = 0;
            rstemp=rs_temp[rs_block_number];
            while (i < rs_ecc_codewords) {
                rstemp=rstemp.concat(new Character((char)0).toString());
                i++;
            }
            
            i = 0;
            while (i < rs_data_codewords) {
                padding_data = padding_data.concat(new Character((char)0).toString());
                i++;
            }
 

            j = rs_data_codewords;
            
            int rstemplength = rstemp.length();
            
            i = 0;
            
            while (i < rstemplength) {
                rstemp2[i] =  new Character(rstemp.charAt(i)).hashCode();
                i++;
            }
            
            
            
            while(j>0){
                
                int first = rstemp2[0];
                
                if (first != 0){
                    
                    i = 0;
            
                    while (i < rstemplength-1) {
                        
                        if (i < rs_ecc_codewords)
                            rstemp2[i] = rstemp2[i+1] ^ rs_cal_table_array[first][i];
                        else
                            rstemp2[i] = rstemp2[i+1] ^ 0;
                        
                        i++;
                    }
                    
                    rstemplength--;
                    
                } else {
                    
                    i = 0;
            
                    while (i < rstemplength-1) {
                        rstemp2[i] = rstemp2[i+1];
                        i++;
                    }
                    
                    rstemplength--;

                }

                j--;
            }
            
            i = 0;
            
            while (i < rstemplength) {
                codewords[codewords_counter_cloned] =  rstemp2[i];
                codewords_counter_cloned ++;
                i++;
            }

            rs_block_number++;
        }
        
         /*for(int ctr=0; ctr<max_codewords; ctr++){
             System.out.print(ctr);
             System.out.print(" => ");
            System.out.println(codewords[ctr]);
        }*/
        
        
        /* ---- flash matrix */
        int matrix_content[][] = new int[max_modules_1side][max_modules_1side];

        i=0;
        while (i<max_modules_1side){
            j=0;
            while (j<max_modules_1side){
                matrix_content[j][i]=0;
                j++;
            }
            i++;
        }
        
        /* --- attach data */

        i=0;
        while (i<max_codewords){
            int codeword_i=codewords[i];
            j=8;
            while (j>=1){
                int codeword_bits_number=(i << 3) +  j;
                
                
                matrix_content[ matrix_x_array[codeword_bits_number-1]][ matrix_y_array[codeword_bits_number-1]]=((255*(codeword_i & 1)) ^ mask_array[codeword_bits_number-1] ); 
                codeword_i = codeword_i >> 1;
                j--;
            }
            i++;
        }
        

        int matrix_remain=matrix_remain_bit[qrcode_version];
        while (matrix_remain != 0){
            int remain_bit_temp = matrix_remain + ( max_codewords <<3);

            int x = 0;
            int y = 0;
            int mask = 0;
            
            if (matrix_x_array.length < remain_bit_temp)
                    x = matrix_x_array[remain_bit_temp];
            
            if (matrix_y_array.length < remain_bit_temp)
                    y = matrix_y_array[remain_bit_temp];
            
            if (mask_array.length < remain_bit_temp)
                    mask = mask_array[remain_bit_temp];
            
                    
            
            matrix_content[ x ][ y ]  =  ( 255 ^ mask  );
            matrix_remain--;
        }
        
        int mask_number = 2;
        
        int mask_content=1 << mask_number;


        int format_information_value=((ec << 3) | mask_number);
        
        int[][] format_information_array= { { 1,0,1,0,1,0,0,0,0,0,1,0,0,1,0} , {1,0,1,0,0,0,1,0,0,1,0,0,1,0,1},{
        1,0,1,1,1,1,0,0,1,1,1,1,1,0,0} , {1,0,1,1,0,1,1,0,1,0,0,1,0,1,1} , {1,0,0,0,1,0,1,1,1,1,1,1,0,0,1} , {1,0,0,0,0,0,0,1,1,0,0,1,1,1,0},{
        1,0,0,1,1,1,1,1,0,0,1,0,1,1,1} , {1,0,0,1,0,1,0,1,0,1,0,0,0,0,0} , {1,1,1,0,1,1,1,1,1,0,0,0,1,0,0} , {1,1,1,0,0,1,0,1,1,1,1,0,0,1,1},{
        1,1,1,1,1,0,1,1,0,1,0,1,0,1,0} , {1,1,1,1,0,0,0,1,0,0,1,1,1,0,1} , {1,1,0,0,1,1,0,0,0,1,0,1,1,1,1} , {1,1,0,0,0,1,1,0,0,0,1,1,0,0,0},{
        1,1,0,1,1,0,0,0,1,0,0,0,0,0,1} , {1,1,0,1,0,0,1,0,1,1,1,0,1,1,0} , {0,0,1,0,1,1,0,1,0,0,0,1,0,0,1} , {0,0,1,0,0,1,1,1,0,1,1,1,1,1,0},{
        0,0,1,1,1,0,0,1,1,1,0,0,1,1,1} , {0,0,1,1,0,0,1,1,1,0,1,0,0,0,0} , {0,0,0,0,1,1,1,0,1,1,0,0,0,1,0} , {0,0,0,0,0,1,0,0,1,0,1,0,1,0,1},{
        0,0,0,1,1,0,1,0,0,0,0,1,1,0,0} , {0,0,0,1,0,0,0,0,0,1,1,1,0,1,1} , {0,1,1,0,1,0,1,0,1,0,1,1,1,1,1} , {0,1,1,0,0,0,0,0,1,1,0,1,0,0,0},{
        0,1,1,1,1,1,1,0,0,1,1,0,0,0,1} , {0,1,1,1,0,1,0,0,0,0,0,0,1,1,0} , {0,1,0,0,1,0,0,1,0,1,1,0,1,0,0} , {0,1,0,0,0,0,1,1,0,0,0,0,0,1,1},{
        0,1,0,1,1,1,0,1,1,0,1,1,0,1,0} , {0,1,0,1,0,1,1,1,1,1,0,1,1,0,1} };
        
        i=0;
        while (i<15){
            int content = format_information_array[format_information_value][i];

            matrix_content[format_information_x1[i]][format_information_y1[i]]= content * 255;
            matrix_content[format_information_x2[i]][format_information_y2[i]] = content * 255; //Y'avait un + 1
            i++;
        }
        
       

        int mxe=max_modules_1side;
        
        i=0;
        
        int data[][] = new int[mxe][mxe];
        
        while (i<mxe){
            j=0;
            while (j<mxe){
                if ((matrix_content[j][i] & mask_content) != 0) {
                    data[i][j] = 1;
                } else {
                    data[i][j] = frame_data_splited[i][j];
                }
                j++;
            }
            
            i++;
           }
                
        /*int data[][] = 
            {
                {1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,0 ,1 ,0 ,1 ,0 ,0 ,1 ,0 ,0 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,1 },
{1 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,0 ,0 ,0 ,1 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,1 ,0 ,0 ,0 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,1 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,0 ,0 ,0 ,0 ,1 ,0 ,1 ,0 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,1 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,1 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,1 },
{1 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,1 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,0 ,0 ,0 ,1 },
{1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,1 },
{0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 },
{1 ,1 ,1 ,1 ,1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 },
{1 ,1 ,1 ,1 ,0 ,0 ,0 ,0 ,1 ,1 ,0 ,1 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,0 ,0 ,1 ,0 ,0 ,0 },
{1 ,1 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,1 ,0 ,0 ,1 ,0 ,0 ,1 ,1 ,0 ,0 ,1 ,1 ,0 ,0 ,1 ,1 },
{0 ,1 ,0 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,1 ,1 ,0 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,1 ,0 ,0 ,0 },
{1 ,1 ,0 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,1 },
{0 ,0 ,1 ,0 ,0 ,1 ,0 ,0 ,0 ,1 ,0 ,1 ,1 ,0 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,1 ,1 ,1 ,0 },
{0 ,1 ,0 ,1 ,1 ,1 ,1 ,0 ,0 ,1 ,1 ,0 ,1 ,1 ,0 ,1 ,1 ,0 ,1 ,1 ,1 ,0 ,0 ,0 ,1 },
{0 ,1 ,1 ,0 ,1 ,1 ,0 ,0 ,0 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,1 ,1 ,0 ,0 ,0 ,0 ,0 ,1 },
{0 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,0 ,1 ,1 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 },
{0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,1 ,1 ,0 ,1 ,0 ,0 ,1 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,0 },
{1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,0 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,0 ,1 ,1 },
{1 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,0 ,1 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,1 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,0 ,1 ,0 ,0 ,1 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,0 ,1 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,0 ,1 ,1 ,0 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,0 },
{1 ,0 ,1 ,1 ,1 ,0 ,1 ,0 ,1 ,1 ,0 ,0 ,1 ,1 ,1 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,0 ,1 },
{1 ,0 ,0 ,0 ,0 ,0 ,1 ,0 ,1 ,0 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,0 ,1 ,1 ,1 ,1 ,0 ,0 ,1 },
{1 ,1 ,1 ,1 ,1 ,1 ,1 ,0 ,1 ,1 ,1 ,0 ,0 ,1 ,0 ,0 ,0 ,1 ,1 ,0 ,0 ,0 ,1 ,1 ,1 }
            };*/
        
        return data;
    }
   
     

}
